/* ----------------------------------------------------------------------------
 * Copyright (c) 2017 Semiconductor Components Industries, LLC (d/b/a
 * ON Semiconductor), All Rights Reserved
 *
 * This code is the property of ON Semiconductor and may not be redistributed
 * in any form without prior written permission from ON Semiconductor.
 * The terms of use and warranty for this code are covered by contractual
 * agreements between ON Semiconductor and the licensee.
 *
 * This is Reusable Code.
 *
 * -----------------------------------------------------------------------------
 */

/* Initialisation before entering the main function. */
.text global 0 _main_init
      r = 1                             /* Enable rounding */
      s = 1                             /* Enable saturation */
      sp = _sp_start_value_DMA          /* Init SP */
      ie = 1 ; nop                      /* Enable interrupts */

/* Area to load main() arguments */
.bss global 0 _main_argv_area DMA 256

.undef global text ARM1_IRQHandler

/* Define an interrupt vector table */
.text global 0 _ivt
    jp _main_init                       /*  0 Reset interrupt */
    reti ; nop                          /*  2 DMA channel 0 interrupt */
    reti ; nop                          /*  4 DMA channel 1 interrupt */
    reti ; nop                          /*  6 DMA channel 2 interrupt */
    reti ; nop                          /*  8 DMA channel 3 interrupt */
    reti ; nop                          /* 10 DMA channel 4 interrupt */
    reti ; nop                          /* 12 DMA channel 5 interrupt */
    reti ; nop                          /* 14 DMA channel 6 interrupt */
    reti ; nop                          /* 16 DMA channel 7 interrupt */
    reti ; nop                          /* 18 ARM Cortex-M3 0 interrupt */
    jp ARM1_IRQHandler                  /* 20 ARM Cortex-M3 1 interrupt */
    reti ; nop                          /* 22 ARM Cortex-M3 2 interrupt */
    reti ; nop                          /* 24 ARM Cortex-M3 3 interrupt */
    reti ; nop                          /* 26 ARM Cortex-M3 4 interrupt */
    reti ; nop                          /* 28 ARM Cortex-M3 5 interrupt */
    reti ; nop                          /* 30 ARM Cortex-M3 6 interrupt */

