# ----------------------------------------------------------------------------
# Copyright (c) 2017 Semiconductor Components Industries, LLC (d/b/a
# ON Semiconductor), All Rights Reserved
#
# This code is the property of ON Semiconductor and may not be redistributed
# in any form without prior written permission from ON Semiconductor.
# The terms of use and warranty for this code are covered by contractual
# agreements between ON Semiconductor and the licensee.
#
# This is Reusable Code.
#
# -----------------------------------------------------------------------------
#

from baseFileStreamWrapper import baseFileStreamWrapper

def toByte(line):
    ''' Helper method to decode two hex characters into a byte '''
    return line[2:4].decode("hex")

class hexByteStream(baseFileStreamWrapper):
    ''' specific file wrapper for a byte stream encoded file '''

    def __init__(self, wrappedFile):
        ''' Constructor takes the file to be wrapped '''
        super(hexByteStream, self).__init__(wrappedFile)
        self._loadFile()
    
    def _loadFile(self):
        ''' load the contents of the file into memory '''
        self.bytes = bytearray(toByte(line) for line in self.wrappedFile)
        self.fp = 0
        
    def read(self, numBytes):
        ''' we only provide a read method on this file type '''
        result = self.bytes[self.fp:self.fp + numBytes]
        print len(result)
        self.seek(numBytes, 1)
        return result
